chrome.runtime.onMessage.addListener(
  function(request, sender, sendResponse) {
    console.log(request)
    if( request.message === "generate" ) {
      generate();
         }
    if( request.message === "fillandstroke" ) {
      fillandstroke(request.state);
         }   
    if( request.message === "downloadSVGAsText" ) {
          downloadSVGAsText();
        }     
    if( request.message === "downloadSVGAsPNG" ) {
          downloadSVGAsPNG();
        }  
  }
);

var strokeState = "off";

var svg;
var finalSVG;

function generate(){
    alert("it starts generating");
    walk(document.body, /(e)/i);

    var doc_width = document.body.clientWidth;
    var doc_height = document.body.clientHeight;

    svg = '<?xml version="1.0"?>' +
              '<svg id="my_svg" width="' + doc_width + '" height="' + doc_height + '" ' +
                  'viewBox="0 0 ' + doc_width + ' ' + doc_height + '" ' +
                  'xmlns="http://www.w3.org/2000/svg">' +
                    '<polygon points="';

    var elements = document.body.querySelectorAll(".my_letter")

    var points = []; 

    elements.forEach(e => {
        var elm_width  = e.offsetWidth;
        var elm_height = e.offsetHeight;
        var elm_x      = e.getBoundingClientRect().left + document.documentElement.scrollLeft;
        var elm_y      = e.getBoundingClientRect().top + document.documentElement.scrollTop;
        
        points.push(elm_x, elm_y)
        svg = svg + elm_x+','+elm_y+' '
    });

    console.log(points)

    // here we define fill and stroke color
    finalSVG = svg + '" fill="none" stroke="black"/></svg>';

    // Here we append the svg to the document
    document.body.insertAdjacentHTML('beforeend', finalSVG);


    function walk(node, targetRe) {
      var child;

      switch (node.nodeType) {
        case 1: // Element
          for (child = node.firstChild;
              child;
              child = child.nextSibling) {
            walk(child, targetRe);
          }
          break;

        case 3: // Text node
          handleText(node, targetRe);
          break;
      }
    }

    function handleText(node, targetRe) {
      var match, targetNode, followingNode, wrapper;

      // Does the text contain our target string?
      // (This would be a regex test in your http://... case)
      match = targetRe.exec(node.nodeValue);
      if (match) {
        // Split at the beginning of the match
        targetNode = node.splitText(match.index);

        // Split at the end of the match.
        // match[0] is the full text that was matched.
        followingNode = targetNode.splitText(match[0].length);

        // Wrap the target in an `a` element.
        // First we create the wrapper and insert it in front
        // of the target text. We use the first capture group
        // as the `href`.
        wrapper = document.createElement('span');
        wrapper.className = "my_letter";
        wrapper.style.backgroundColor = "none";
        wrapper.style.opacity = "50%";
        wrapper.style.display = "inline-block";
        wrapper.style.position = "relative";
        targetNode.parentNode.insertBefore(wrapper, targetNode);

        // Now we move the target text inside it
        wrapper.appendChild(targetNode);

        // Clean up any empty nodes (in case the target text
        // was at the beginning or end of a text ndoe)
        if (node.nodeValue.length == 0) {
          node.parentNode.removeChild(node);
        }
        if (followingNode.nodeValue.length == 0) {
          followingNode.parentNode.removeChild(followingNode);
        }

        // Continue with the next match in the node, if any
        match = followingNode
          ? targetRe.exec(followingNode.nodeValue)
          : null;
      }
    }

}


 function fillandstroke (state) {
  if(state == "off"){
    document.getElementById("my_svg").remove();
    // here we define fill and stroke color
    finalSVG = svg + '" fill="none" stroke="black"/></svg>';

    // Here we append the svg to the document
    document.body.insertAdjacentHTML('beforeend', finalSVG);
  }
  else{

    document.getElementById("my_svg").remove();
    // here we define fill and stroke color
    finalSVG = svg + '" fill="black" stroke="none"/></svg>';

    // Here we append the svg to the document
    document.body.insertAdjacentHTML('beforeend', finalSVG);

  }
}



function downloadSVGAsText() {
  const svg = document.querySelector('#my_svg');
  const base64doc = btoa(unescape(encodeURIComponent(svg.outerHTML)));
  const a = document.createElement('a');
  const e = new MouseEvent('click');
  a.download = 'generator_shape.svg';
  a.href = 'data:image/svg+xml;base64,' + base64doc;
  a.dispatchEvent(e);
}



function downloadSVGAsPNG(e){
     const canvas = document.createElement("canvas");
    const svg = document.querySelector('#my_svg');
     const base64doc = btoa(unescape(encodeURIComponent(svg.outerHTML)));
     const w = parseInt(svg.getAttribute('width'));
     const h = parseInt(svg.getAttribute('height'));
     const img_to_download = document.createElement('img');
     img_to_download.src = 'data:image/svg+xml;base64,' + base64doc;
     console.log(w, h);
     img_to_download.onload = function () {
       console.log('img loaded');
       canvas.setAttribute('width', w);
       canvas.setAttribute('height', h);
       const context = canvas.getContext("2d");
       //context.clearRect(0, 0, w, h);
       context.drawImage(img_to_download,0,0,w,h);
       const dataURL = canvas.toDataURL('image/png');
       if (window.navigator.msSaveBlob) {
         window.navigator.msSaveBlob(canvas.msToBlob(), "download.png");
         e.preventDefault();
       } else {
         const a = document.createElement('a');
         const my_evt = new MouseEvent('click');
         a.download = 'generated_shape.png';
         a.href = dataURL;
         a.dispatchEvent(my_evt);
       }
      canvas.parentNode.removeChild(canvas);
     }  
   }



















// function downloadSVGAsText() {
//   const svg = document.querySelector('svg');
//   const base64doc = btoa(unescape(encodeURIComponent(svg.outerHTML)));
//   const a = document.createElement('a');
//   const e = new MouseEvent('click');
//   a.download = 'download.svg';
//   a.href = 'data:image/svg+xml;base64,' + base64doc;
//   a.dispatchEvent(e);
// }

// function downloadSVGAsPNG(e){
//   const canvas = document.createElement("canvas");
//   const svg = document.querySelector('svg');
//   const base64doc = btoa(unescape(encodeURIComponent(svg.outerHTML)));
//   const w = parseInt(svg.getAttribute('width'));
//   const h = parseInt(svg.getAttribute('height'));
//   const img_to_download = document.createElement('img');
//   img_to_download.src = 'data:image/svg+xml;base64,' + base64doc;
//   console.log(w, h);
//   img_to_download.onload = function () {
//     console.log('img loaded');
//     canvas.setAttribute('width', w);
//     canvas.setAttribute('height', h);
//     const context = canvas.getContext("2d");
//     //context.clearRect(0, 0, w, h);
//     context.drawImage(img_to_download,0,0,w,h);
//     const dataURL = canvas.toDataURL('image/png');
//     if (window.navigator.msSaveBlob) {
//       window.navigator.msSaveBlob(canvas.msToBlob(), "download.png");
//       e.preventDefault();
//     } else {
//       const a = document.createElement('a');
//       const my_evt = new MouseEvent('click');
//       a.download = 'download.png';
//       a.href = dataURL;
//       a.dispatchEvent(my_evt);
//     }
//     //canvas.parentNode.removeChild(canvas);
//   }  
// }

// const downloadSVG = document.querySelector('#downloadSVG');
// downloadSVG.addEventListener('click', downloadSVGAsText);
// const downloadPNG = document.querySelector('#downloadPNG');
// downloadPNG.addEventListener('click', downloadSVGAsPNG);



// // JETZT KOMMT SVG UND EXPORT


// walk(document.body, /(a)/i);

// var doc_width = document.body.clientWidth;
// var doc_height = document.body.clientHeight;

// var svg = '<?xml version="1.0"?>' +
//           '<svg width="' + doc_width + '" height="' + doc_height + '" ' +
//                'viewBox="0 0 ' + doc_width + ' ' + doc_height + '" ' +
//                'xmlns="http://www.w3.org/2000/svg">' +
//                 '<polygon points="';

// var elements = document.body.querySelectorAll(".my_letter")

// var points = []; 

// elements.forEach(e => {
//     var elm_width  = e.offsetWidth;
//     var elm_height = e.offsetHeight;
//     var elm_x      = e.getBoundingClientRect().left + document.documentElement.scrollLeft;
//     var elm_y      = e.getBoundingClientRect().top + document.documentElement.scrollTop;
    
//     points.push(elm_x, elm_y)
//     svg = svg + elm_x+','+elm_y+' '
// });

// console.log(points)

// svg = svg + '" fill="none" stroke="black"/></svg>';

// copy(svg);

// console.log( 'SVG code ist nun in der Zwischenablage!' );




// function walk(node, targetRe) {
//   var child;

//   switch (node.nodeType) {
//     case 1: // Element
//       for (child = node.firstChild;
//            child;
//            child = child.nextSibling) {
//         walk(child, targetRe);
//       }
//       break;

//     case 3: // Text node
//       handleText(node, targetRe);
//       break;
//   }
// }

// function handleText(node, targetRe) {
//   var match, targetNode, followingNode, wrapper;

//   // Does the text contain our target string?
//   // (This would be a regex test in your http://... case)
//   match = targetRe.exec(node.nodeValue);
//   if (match) {
//     // Split at the beginning of the match
//     targetNode = node.splitText(match.index);

//     // Split at the end of the match.
//     // match[0] is the full text that was matched.
//     followingNode = targetNode.splitText(match[0].length);

//     // Wrap the target in an `a` element.
//     // First we create the wrapper and insert it in front
//     // of the target text. We use the first capture group
//     // as the `href`.
//     wrapper = document.createElement('span');
//         wrapper.className = "my_letter";
//         wrapper.style.backgroundColor = "yellow";
//     targetNode.parentNode.insertBefore(wrapper, targetNode);

//     // Now we move the target text inside it
//     wrapper.appendChild(targetNode);

//     // Clean up any empty nodes (in case the target text
//     // was at the beginning or end of a text ndoe)
//     if (node.nodeValue.length == 0) {
//       node.parentNode.removeChild(node);
//     }
//     if (followingNode.nodeValue.length == 0) {
//       followingNode.parentNode.removeChild(followingNode);
//     }

//     // Continue with the next match in the node, if any
//     match = followingNode
//       ? targetRe.exec(followingNode.nodeValue)
//       : null;
//   }
// }